Package org.apache.catalina.mbeans

## Class ContainerMBean

- java.lang.Object
- - org.apache.tomcat.util.modeler.BaseModelMBean
  - - org.apache.catalina.mbeans.BaseCatalinaMBean<ContainerBase>
    - - org.apache.catalina.mbeans.ContainerMBean

All Implemented Interfaces:
  `javax.management.DynamicMBean`, `javax.management.MBeanRegistration`, `javax.management.modelmbean.ModelMBeanNotificationBroadcaster`, `javax.management.NotificationBroadcaster`

    public class ContainerMBean
    extends BaseCatalinaMBean<ContainerBase>

### Field Summary

### Fields inherited from class org.apache.tomcat.util.modeler.BaseModelMBean

`attributeBroadcaster, generalBroadcaster, managedBean, oname, resource, resourceType`

### Constructor Summary

Constructors
`ContainerMBean()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addChild​(java.lang.String type, java.lang.String name)` Add a new child Container to those associated with this Container, if supported.
`void` `addLifecycleListener​(java.lang.String type)` Add a LifecycleEvent listener to this component.
`java.lang.String` `addValve​(java.lang.String valveType)` Adds a valve to this Container instance.
`java.lang.String[]` `findContainerListenerNames()` List the class name of each of the container listeners added to this container.
`java.lang.String[]` `findLifecycleListenerNames()` List the class name of each of the lifecycle listeners added to this container.
`void` `removeChild​(java.lang.String name)` Remove an existing child Container from association with this parent Container.
`void` `removeLifecycleListeners​(java.lang.String type)` Remove a LifecycleEvent listeners from this component.
`void` `removeValve​(java.lang.String valveName)` Remove an existing Valve.

### Methods inherited from class org.apache.catalina.mbeans.BaseCatalinaMBean

`doGetManagedResource, newInstance`

### Methods inherited from class org.apache.tomcat.util.modeler.BaseModelMBean

`addAttributeChangeNotificationListener, addNotificationListener, getAttribute, getAttributes, getClassName, getJmxName, getManagedResource, getMBeanInfo, getModelerType, getNotificationInfo, getObjectName, invoke, postDeregister, postRegister, preDeregister, preRegister, removeAttributeChangeNotificationListener, removeNotificationListener, sendAttributeChangeNotification, sendAttributeChangeNotification, sendNotification, sendNotification, setAttribute, setAttributes, setManagedBean, setManagedResource, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ContainerMBean

    public ContainerMBean()

### Method Detail

#### addChild

    public void addChild​(java.lang.String type,
                         java.lang.String name)
                  throws javax.management.MBeanException

Add a new child Container to those associated with this Container, if supported. Won't start the child yet. Has to be started with a call to Start method after necessary configurations are done.

Parameters:
  `type` - ClassName of the child to be added
  `name` - Name of the child to be added
Throws:
  `javax.management.MBeanException` - if the child cannot be added

#### removeChild

    public void removeChild​(java.lang.String name)
                     throws javax.management.MBeanException

Remove an existing child Container from association with this parent Container.

Parameters:
  `name` - Name of the existing child Container to be removed
Throws:
  `javax.management.MBeanException` - if the child cannot be removed

#### addValve

    public java.lang.String addValve​(java.lang.String valveType)
                              throws javax.management.MBeanException

Adds a valve to this Container instance.

Parameters:
  `valveType` - ClassName of the valve to be added
Returns:
  the MBean name of the new valve
Throws:
  `javax.management.MBeanException` - if adding the valve failed

#### removeValve

    public void removeValve​(java.lang.String valveName)
                     throws javax.management.MBeanException

Remove an existing Valve.

Parameters:
  `valveName` - MBean Name of the Valve to remove
Throws:
  `javax.management.MBeanException` - if a component cannot be removed

#### addLifecycleListener

    public void addLifecycleListener​(java.lang.String type)
                              throws javax.management.MBeanException

Add a LifecycleEvent listener to this component.

Parameters:
  `type` - ClassName of the listener to add
Throws:
  `javax.management.MBeanException` - if adding the listener failed

#### removeLifecycleListeners

    public void removeLifecycleListeners​(java.lang.String type)
                                  throws javax.management.MBeanException

Remove a LifecycleEvent listeners from this component.

Parameters:
  `type` - The ClassName of the listeners to be removed. Note that all the listeners having given ClassName will be removed.
Throws:
  `javax.management.MBeanException` - propagated from the managed resource access

#### findLifecycleListenerNames

    public java.lang.String[] findLifecycleListenerNames()
                                                  throws javax.management.MBeanException

List the class name of each of the lifecycle listeners added to this container.

Returns:
  the lifecycle listeners class names
Throws:
  `javax.management.MBeanException` - propagated from the managed resource access

#### findContainerListenerNames

    public java.lang.String[] findContainerListenerNames()
                                                  throws javax.management.MBeanException

List the class name of each of the container listeners added to this container.

Returns:
  the container listeners class names
Throws:
  `javax.management.MBeanException` - propagated from the managed resource access